;Copyright (C) 2000 Jun Mizutani <mizutani.jun@nifty.ne.jp>
;
; file          : fcntl.inc
; created       : 2000/05/21
; derived from  : linux-2.2.14/include/asm-i386/fcntl.h

%ifndef __FCNTL_INC
%define __FCNTL_INC


%include "vartype.inc"

;  open/fcntl - O_SYNC is only implemented on blocks devices and on files
;  located on an ext2 file system

%assign O_ACCMODE          0003q
%assign O_RDONLY             00q
%assign O_WRONLY             01q
%assign O_RDWR               02q
%assign O_CREAT            0100q ;  not fcntl
%assign O_EXCL             0200q ;  not fcntl
%assign O_NOCTTY           0400q ;  not fcntl
%assign O_TRUNC           01000q ;  not fcntl
%assign O_APPEND          02000q
%assign O_NONBLOCK        04000q
%assign O_NDELAY        O_NONBLOCK
%assign O_SYNC           010000q
%assign FASYNC           020000q ;  fcntl, for BSD compatibility
%assign O_DIRECT         040000q ;  direct disk access hint - currently ignored
%assign O_LARGEFILE     0100000q
%assign O_DIRECTORY     0200000q ;  must be a directory
%assign O_NOFOLLOW      0400000q ;  don't follow links

%assign F_DUPFD         0       ;  dup
%assign F_GETFD         1       ;  get f_flags
%assign F_SETFD         2       ;  set f_flags
%assign F_GETFL         3       ;  more flags (cloexec)
%assign F_SETFL         4
%assign F_GETLK         5
%assign F_SETLK         6
%assign F_SETLKW        7

%assign F_SETOWN        8       ;   for sockets.
%assign F_GETOWN        9       ;   for sockets.
%assign F_SETSIG        10      ;   for sockets.
%assign F_GETSIG        11      ;   for sockets.

;  for F_[GET|SET]FL
%assign FD_CLOEXEC      1       ;  actually anything with low bit set goes

;  for posix fcntl() and lockf()
%assign F_RDLCK         0
%assign F_WRLCK         1
%assign F_UNLCK         2

;  for old implementation of bsd flock ()
%assign F_EXLCK         4       ;  or 3
%assign F_SHLCK         8       ;  or 4

;  operations for bsd flock(), also used by the kernel implementation
%assign LOCK_SH         1       ;  shared lock
%assign LOCK_EX         2       ;  exclusive lock
%assign LOCK_NB         4       ;  or'd with one of the above to prevent
                                   blocking
%assign LOCK_UN         8       ;  remove lock

struc flock
        .l_type    USHORT    1;
        .l_whence  USHORT    1;
        .l_start   LONG      1;
        .l_len     LONG      1;
        .l_pid     LONG      1;
endstruc

%endif
