;----------------------------------------------------------------------
; Stack Dump    2000/ 4/24
;     Copyright (C) 2000 Jun Mizutani  <mizutani.jun@nifty.ne.jp>
; name  : stackdump.asm
; usage : stackdump dummyargs ..
;----------------------------------------------------------------------

section .bss

dummy   resd  1

section .data

msg     db    "Program Counter : ", 0
msg1    db    "Data Section    : ", 0
msg2    db    "Stack Pointer   : ", 0
msg3    db    "BSS Section     : ", 0

section .text
global _start

_start:
        call    .skip
.skip   pop     eax                 ; Set IP into eax
        mov     ebx, eax
        mov     eax, msg
        call    OutAsciiZ
        mov     eax, ebx
        call    PrintHex8           ; print IP
        call    NewLine
        mov     eax, msg1
        call    OutAsciiZ
        mov     eax, msg
        call    PrintHex8           ; print data section address
        call    NewLine
        mov     eax, msg3
        call    OutAsciiZ
        mov     eax, dummy
        call    PrintHex8           ; print bss section address
        call    NewLine
        mov     eax, msg2
        call    OutAsciiZ
        mov     eax, esp
        call    PrintHex8           ; print Stack Pointer
        call    NewLine
        call    NewLine
        mov     ebp, esp
        mov     ebx, [ebp]          ; argc
        add     ebx, 2
        shl     ebx, 2
        add     ebp, ebx            ; skip argv

.dispenv:
        mov     eax, [ebp]
        or      eax, eax
        jz      .endenv
        call    OutAsciiZ           ; env
        call    NewLine
        add     ebp, 4
        jmp     short .dispenv
.endenv
        call    NewLine

.displine:
        mov     eax, ebp
        call    PrintHex8
        mov     al, ':'
        call    OutChar
        mov     ecx, 16

        push    ebp
.loop1:
        cmp     ebp, 0xC0000000
        jae     .next
        mov     al, [ebp]
        call    PrintHex2
        mov     al, ' '
        call    OutChar
        inc     ebp
        loop    .loop1
.next:
        mov     al, ' '
        call    OutChar
        mov     ecx, 4
        pop     ebp

.loop2:
        cmp     ebp, 0xC0000000
        jae     .exit
        mov     eax, [ebp]
        call    OutChar4            ; print stack contents in ASCII
        add     ebp, 4
        loop    .loop2
        call    NewLine
        jmp     .displine
.exit
        call    NewLine
        call    Exit

%include "stdio.inc"

